add copyright headers, fix a few things
[distro-setup] / distro-end
index 3ebc231f1510932151f88ad263380034d2888de7..44be816d82fee63536c3a83adce2ad8bb5aa47a9 100755 (executable)
@@ -1,20 +1,37 @@
 #!/bin/bash -l
 # Copyright (C) 2016 Ian Kelling
-# This program is under GPL v. 3 or later, see <http://www.gnu.org/licenses/>
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+
+#     http://www.apache.org/licenses/LICENSE-2.0
+
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+errcatch
 
 set -x
 
 exec &> >(sudo tee -a /var/log/distro-end)
 echo "$0: $(date): starting now)"
 
+src="${BASH_SOURCE%/*}"
+
 end_msg() {
     =    local y
     IFS= read -r -d '' y  ||:
     end_msg_var+="$y"
 }
 
+spa() { # simple package add
+    simple_packages+=($@)
+}
+
 distro=$(distro-name)
 
 pending_reboot=false
@@ -25,57 +42,251 @@ esac
 
 pup
 
-# universal packages
 simple_packages=(
-    bwm-ng
-    chromium
-    duplicity
-    evince
-    fdupes
-    filelight
-    gdb
-    gnome-screenshot
+    htop
     mailutils
-    meld
-    mpv
     nmon
-    offlineimap
-    p7zip
-    paprefs
-    pavucontrol
-    pianobar
-    pidgin
     rdiff-backup
-    slock
-    smartmontools
-    squashfs-tools
-    tcpdump
-    transmission-remote-gtk
+    ruby
+    ruby-rest-client
     tree
     vim
 )
 
-spa() { # simple package add
-    simple_packages+=($@)
-}
+case $HOSTNAME in
+    lj|li) : ;;
+    *)
+        # universal packages
+        # swh-plugins is for karaoke pulsaudio filter.
+        # mutagen for pithos
+        # lib32stdc++6/default-jdk for android studio
+        # android site says it needs a bunch of packages for ubuntu,
+        # but I googled for debian, and someone says you just need one, plus the
+        # jdk
+        # https://pid7007blog.blogspot.com/2015/07/installing-android-studio-in-debian-8.html
+        # see w.org for more android studio details
+        #
+        simple_packages+=(
+            apache2
+            bwm-ng
+            chromium
+            default-jdk
+            duplicity
+            evince
+            fdupes
+            filelight
+            gdb
+            gitk
+            goaccess
+            gnome-screenshot
+            jq
+            locate
+            lib32stdc++6
+            manpages
+            meld
+            nmap
+            offlineimap
+            p7zip
+            paprefs
+            pavucontrol
+            pdfgrep
+            pianobar
+            pidgin
+            python3-mutagen
+            slock
+            squashfs-tools
+            swh-plugins
+            tcpdump
+            transmission-remote-gtk
+            vlc
+        )
+        ;;
+esac
+
+
+
+########### begin section including li ################
+
+
+case $distro in
+    debian)
+        if [[ `debian-archive` == testing ]]; then
+            pi acme-tiny
+        fi
+esac
+
+case $distro in
+    fedora) spa unrar ;;
+    *) spa unrar-free ;;
+esac
 
 
 case $distro in
-    debian) pi curl ;;
+    arch)
+        # ubuntu 14.04 uses b-cron,
+        # but its not maintained in arch.
+        # of the ones in the main repos, cronie is only one maintained.
+        # fcron appears abandoned software.
+        pi cronie
+        sgo cronie
+        ;;
+    *) : ;; # other distros come with cron.
+esac
+
+
+case $distro in
+    debian|ubuntu)
+        pi debian-goodies
+        ;;
+esac
+
+
+case $distro in
+    *) pi at ;;&
+    arch) sgo atd ;;
+esac
+
+
+case $distro in
+    debian) pi curl;;
     arch) : ;;
     # fedora: unknown
 esac
 
+case $distro in
+    # tk for gitk
+    arch) spa git tk ;;
+    *) spa git ;;
+esac
+
+case $distro in
+    arch) spa the_silver_searcher ;;
+    debian|ubuntu) spa silversearcher-ag ;;
+    # fedora unknown
+esac
+
+case $distro in
+    debian|ubuntu) spa ntp;;
+    arch)
+        pi ntp
+        sgo ntpd
+        ;;
+    # others unknown
+esac
+
+
+# no equivalent in other distros:
+case $distro in
+    debian|ubuntu)
+        pi apt-file aptitude
+        s apt-file update
+        # for debconf-get-selections
+        spa debconf-utils
+        ;;
+esac
+
+case $distro in
+    ubuntu|debian) spa ack-grep ;;
+    arch|fedora) spa ack ;;
+    # fedora unknown
+esac
+
+case $distro in
+    arch|debian|ubuntu)
+        spa bash-completion
+        ;;
+    # others unknown
+esac
+
+
+
+
+
+# disable motd junk.
+case $(distro-name) in
+    debian)
+        # allows me to pipe with ssh -t, and gets rid of spam
+        # http://forums.debian.net/viewtopic.php?f=5&t=85822
+        # i'd rather disable the service than comment the init file
+        # this says disabling the service, it will still get restarted
+        # but this script doesn't do anything on restart, so it should be fine
+        s dd of=/var/run/motd.dynamic if=/dev/null
+        # stretch doesn't have initscripts pkg installed by default
+        if [[ $(debian-codename) == jessie ]]; then
+            s update-rc.d motd disable
+        fi
+        ;;
+    ubuntu)
+        # this isn't a complete solution. It still shows me when updates are available,
+        # but it's no big deal.
+        s t /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
+        ;;
+esac
+
+# automatic updates
+# reference:
+# https://debian-handbook.info/browse/stable/sect.regular-upgrades.html
+# /etc/cron.daily/apt calls unattended-upgrades
+# /usr/share/doc/unattended-upgrades# cat README.md
+# /etc/apt/apt.conf.d/50unattended-upgrades
+if isdebian; then
+    setup-debian-auto-update
+fi
+
+# we've got a few dependencies later on, so install them now.
+pi "${simple_packages[@]}"
+simple_packages=()
+
+case $HOSTNAME in
+    lj|li)
+
+        case $HOSTNAME in
+            lj) domain=iank.bid ;;
+            li) domain=iankelling.org ;;
+        esac
+        /a/h/setup.sh $domain
+        /a/h/build.rb
+
+        sudo -E /a/bin/mediawiki-setup/mw-setup-script
+        #$src/phab-setup
+
+        echo "$0: $(date): ending now)"
+        exit 0
+        ;;
+esac
+
+########### end section including li/lj ###############
+
+
+if [[ $HOSTNAME == frodo ]]; then
+    case $distro in
+        ubunut|debian)
+            pi libsqlite3-dev
+            cd /a/opt/duperemove
+            make clean
+            make
+            s make install
+            ;;
+        #others unknown
+    esac
+fi
+
 case $distro in
     arch) pi syncthing ;;
     ubuntu|debian)
-        # google led me here:
-        # https://apt.syncthing.net/
-        curl -s https://syncthing.net/release-key.txt | sudo apt-key add -
-        s="deb http://apt.syncthing.net/ syncthing release"
-        if [[ $(cat /etc/apt/sources.list.d/syncthing.list) != $s ]]; then
-            echo "$s" | s dd of=/etc/apt/sources.list.d/syncthing.list
-            p update
+        # testing has relatively up to date packages
+        if ! isdebian-testing; then
+            # based on error when doing apt-get update:
+            # E: The method driver /usr/lib/apt/methods/https could not be found.
+            pi apt-transport-https
+            # google led me here:
+            # https://apt.syncthing.net/
+            curl -s https://syncthing.net/release-key.txt | sudo apt-key add -
+            s="deb http://apt.syncthing.net/ syncthing release"
+            if [[ $(cat /etc/apt/sources.list.d/syncthing.list) != $s ]]; then
+                echo "$s" | s dd of=/etc/apt/sources.list.d/syncthing.list
+                p update
+            fi
         fi
         pi syncthing
         ;;
@@ -92,36 +303,25 @@ esac
 # trash can versioning for sake of space on phone, with
 # clean out after 7 days.
 #
-# did ser syncthing@ian start
+# did:
+# ser start syncthing@ian
 # then on phone, add device, hit bar code icon,
 # install bar code scanner.
 
 
-# things with no equivalent in other distros:
+# no equivalent in other distros:
 case $distro in
     debian|ubuntu)
         # for gui bug reporting
         spa python-vte
-        pi apt-file aptitude
-        s apt-file update
-        # for debconf-get-selections
-        spa debconf-utils
         ;;
 esac
 
 
 ####### misc packages ###########
 
-case $distro in
-    ubuntu|debian)
-        spa spacefm-gtk3 ;;
-    arch)
-        spa spacefm ;;
-esac
-
-
 
-if [[ $HOSTNAME == frodo ]]; then
+if [[ $HOSTNAME == treetowl ]]; then
     case $distro in
         debian|ubuntu)
             # note i had to do this, which is persistent:
@@ -138,7 +338,7 @@ EOF
             s sysctl -p
 
             # some reason it doesn't seem to start automatically anyways
-            pi-nostart tranmission-daemon
+            pi-nostart transmission-daemon
             # config file documented here, and it's the same config
             # for daemon vs client, so it's documented in the gui.
             # https://trac.transmissionbt.com/wiki/EditConfigFiles#Options
@@ -146,14 +346,14 @@ EOF
 require 'json'
 p = '/etc/transmission-daemon/settings.json'
 File.write(p, JSON.pretty_generate(JSON.parse(File.read(p)).merge({
-'rpc-whitelist': '127.0.0.1,192.168.1.*',
-'rpc-authentication-required': false,
-'incomplete-dir': '/i/k/partial-torrents',
-'download-dir': '/i/k/torrents',
-"speed-limit-up": 700,
-"speed-limit-up-enabled": true,
-"ratio-limit": 1.4000,
-"ratio-limit-enabled": true,
+'rpc-whitelist' => '127.0.0.1,192.168.1.*',
+'rpc-authentication-required' => false,
+'incomplete-dir' => '/i/k/partial-torrents',
+'download-dir' => '/i/k/torrents',
+"speed-limit-up" => 700,
+"speed-limit-up-enabled" => true,
+"ratio-limit" => 1.4000,
+"ratio-limit-enabled" => true,
 })) + "\n")
 EOF
             sgo transmission-daemon
@@ -188,6 +388,11 @@ if ! getent passwd debian-transmission > /dev/null; then
     esac
 fi
 
+# dunno why it's there, but get rid of it
+case $HOSTNAME in
+    li|lj) s rm -rf /home/linode ;;
+esac
+
 # arch had a default config,
 # debian had nothing until you start it.
 # With a little trial an error, here is a minimal config
@@ -197,7 +402,6 @@ fi
 # only settings I set were
 # hostname
 # auto-connect
-#
 for f in /home/*; do
     d=$f/.config/transmission-remote-gtk
     u=${f##*/}
@@ -207,7 +411,7 @@ for f in /home/*; do
   "profiles" : [
     {
       "profile-name" : "Default",
-      "hostname" : "frodo",
+      "hostname" : "treetowl",
       "rpc-url-path" : "/transmission/rpc",
       "username" : "",
       "password" : "",
@@ -236,235 +440,146 @@ done
 case $distro in
     debian|ubuntu)
         pi-nostart openvpn
-        # pi-nostart this doesn't seem to be good enough?
+        # pi-nostart this doesnt seem to be good enough?
         ser disable openvpn@client
         ser disable openvpn
         ;;
-        *) pi openvpn ;;
-    esac
-
-    case $HOSTNAME in
-        tp|frodo)
-            case $distro in
-                debian|ubuntu)
-                    log=$(mktemp)
-                    cd /a/opt
-                    wget -N https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
-                    set +e
-                    s dpkg -i google-chrome-stable_current_amd64.deb &> $log
-                    code=$?
-                    set -e
-                    case $code in
-                        1)
-                            if grep '^dpkg: dependency problems prevent configuration of' \
-                                    $log &>/dev/null; then
-                                s apt-get -fy install
-                            else
-                                exit 1
-                            fi
-                            ;;
-                        0) : ;;
-                        *) exit $code
-                    esac
-                    ;;
-                arch)
-                    pi google-chrome
-                    ;;
-            esac
-            ;;
-    esac
-
-    case $distro in
-        # ubuntu unknown. probably the same as debian, just check if the
-        # init scripts come with the package.
-        debian)
-            # copied from arch, but moved to etc
-            s dd of=/etc/systemd/user/synergys.service <<'EOF'
-[Unit]
-Description=Synergy Server Daemon
-After=network.target
-
-[Service]
-User=%i
-ExecStart=/usr/bin/synergys --no-daemon --config /etc/synergy.conf
-Restart=on-failure
-
-[Install]
-WantedBy=multi-user.target
-EOF
-            s dd of=/etc/systemd/user/synergys.socket <<'EOF'
-[Unit]
-Conflicts=synergys@.service
-
-[Socket]
-ListenStream=24800
-Accept=false
-
-[Install]
-WantedBy=sockets.target
-EOF
-            ;;&
-        *)
-            pi synergy
-            # taken from arch wiki.
-            s dd of=/etc/systemd/system/synergyc@.service <<'EOF'
-[Unit]
-Description=Synergy Client
-After=network.target
-
-[Service]
-User=%i
-ExecStart=/usr/bin/synergyc --no-daemon treetowl
-Restart=on-failure
-# per man systemd.unit, StartLimitInterval, by default we
-# restart more than 5 times in 10 seconds.
-# And this param defaults too 200 miliseconds.
-RestartSec=3s
-
-[Install]
-WantedBy=multi-user.target
-EOF
-            case $HOSTNAME in
-                frodo)
-                    sgo synergyc@ian
-                    systemctl --user start synergys
-                    systemctl --user enable synergys
-                    ;;
-                treetowl) systemctl --user enable synergys ;;
-            esac
-            ;;
-    esac
-
-    case $distro in
-        # tk for gitk
-        arch) spa git tk ;;
-        *) spa git ;;
-    esac
-
-    case $distro in
-        arch) spa the_silver_searcher ;;
-        debian|ubuntu) spa silversearcher-ag ;;
-        # fedora unknown
-    esac
+    # suggests because we want the resolvconf package
+    *) pi --install-suggests openvpn;;
+esac
 
-    # printer
-    case $distro in
-        arch)
-            pi cups ghostscript gsfonts # from arch wiki cups page
-            pi hplip # from google
-            s gpasswd -a $USER sys # from arch wiki
-            sgo org.cups.cupsd.service
-            # goto http://127.0.0.1:631
-            # administration tab, add new printer button.
-            # In debian, I could use hte recommended driver,
-            # in arch, I had to pick out the 6L driver.
-            ;;
-        debian|ubuntu)
-            spa hplip
-            ;;
-        # other distros unknown
-    esac
+pi wget
+case $HOSTNAME in
+    tp|frodo)
+        case $distro in
+            debian|ubuntu)
+                log=$(mktemp)
+                cd /a/opt
+                wget -nv -N https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
+                errallow
+                set -o pipefail
+                s dpkg -i google-chrome-stable_current_amd64.deb |& tee $log
+                code=$?
+                errcatch
+                case $code in
+                    0) : ;;
+                    *)
+                        # previously I had a more specific search, but dpkg
+                        # changed it's output as of 7/2016
+                        if grep 'dependency problems' \
+                                $log &>/dev/null; then
+                            s apt-get -fy install
+                        else
+                            exit 1
+                        fi
+                        ;;
+esac
+;;
+arch)
+    pi google-chrome
+    ;;
+esac
+;;
+esac
 
+# printer
+case $distro in
+    arch)
+        pi cups ghostscript gsfonts # from arch wiki cups page
+        pi hplip # from google
+        s gpasswd -a $USER sys # from arch wiki
+        sgo org.cups.cupsd.service
+        # goto http://127.0.0.1:631
+        # administration tab, add new printer button.
+        # In debian, I could use hte recommended driver,
+        # in arch, I had to pick out the 6L driver.
+        ;;
+    debian|ubuntu)
+        spa hplip
+        ;;
+    # other distros unknown
+esac
 
-    case $distro in
-        ubuntu|debian) spa ack-grep ;;
-        arch|fedora) spa ack ;;
-        # fedora unknown
-    esac
-    case $distro in
-        ubuntu|debian) pi --no-install-recommends mairix notmuch ;;
-        fedora|arch) spa mairix notmuch ;;
-    esac
-    case $distro in
-        arch) spa nfs-utils ;;
-        ubuntu|debian) spa nfs-client ;;
-    esac
-    case $distro in
-        ubuntu|debian) spa par2 ;;
-        arch|fedora) spa par2cmdline ;;
-    esac
 
-    # needed for my tex resume
-    case $distro in
-        ubuntu|debian) spa texlive-full ;;
-        arch) spa texlive-most ;;
-        # fedora unknown
-    esac
+case $distro in
+    ubuntu|debian) pi --no-install-recommends mairix notmuch ;;
+    fedora|arch) spa mairix notmuch ;;
+esac
+case $distro in
+    arch) spa nfs-utils ;;
+    ubuntu|debian) spa nfs-client ;;
+esac
+case $distro in
+    ubuntu|debian) spa par2 ;;
+    arch|fedora) spa par2cmdline ;;
+esac
 
-    case $distro in
-        ubuntu)
-            # flash, unrar, codecs, ms fonts.
-            # This has a manual prompt.
-            spa ubuntu-restricted-extras
-            ;;
-        fedora)
-            pi yum-utils
-            # rpm fusion recommended codecs
-            s su -c "yum localinstall -y --nogpgcheck http://download1.rpmfusion.org/free/fedora/rpmfusion-free-release-$(rpm -E %fedora).noarch.rpm http://download1.rpmfusion.org/nonfree/fedora/rpmfusion-nonfree-release-$(rpm -E %fedora).noarch.rpm"
-            pi gstreamer-plugins-ugly gstreamer-plugins-bad gstreamer-ffmpeg\
-               xine-lib-extras-freeworld
-            ;;
-    esac
+# needed for my tex resume
+case $distro in
+    ubuntu|debian) spa texlive-full ;;
+    arch) spa texlive-most ;;
+    # fedora unknown
+esac
 
-    case $distro in
-        # optional dep for firefox for h.264 video
-        arch) spa gst-libav ;;
-        # other distros, probably come by default
-    esac
+case $distro in
+    ubuntu)
+        # flash, unrar, codecs, ms fonts.
+        # This has a manual prompt.
+        spa ubuntu-restricted-extras
+        ;;
+    fedora)
+        pi yum-utils
+        # rpm fusion recommended codecs
+        s su -c "yum localinstall -y --nogpgcheck http://download1.rpmfusion.org/free/fedora/rpmfusion-free-release-$(rpm -E %fedora).noarch.rpm http://download1.rpmfusion.org/nonfree/fedora/rpmfusion-nonfree-release-$(rpm -E %fedora).noarch.rpm"
+        pi gstreamer-plugins-ugly gstreamer-plugins-bad gstreamer-ffmpeg\
+           xine-lib-extras-freeworld
+        ;;
+esac
 
-    case $distro in
-        fedora|ubuntu|debian) spa gnupg-agent ;;
-        arch) : ;;
-    esac
+case $distro in
+    # optional dep for firefox for h.264 video
+    arch) spa gst-libav ;;
+    # other distros, probably come by default
+esac
 
+case $distro in
+    fedora|ubuntu|debian) spa gnupg-agent ;;
+    arch) : ;;
+esac
 
-    case $distro in
-        fedora) spa pinentry-gtk ;;
-        *) : ;; # comes default or with other packages
-    esac
 
-    case $distro in
-        arch) spa firefox pulseaudio;;
-        *) : ;; # comes default or with other packages
-    esac
+case $distro in
+    fedora) spa pinentry-gtk ;;
+    *) : ;; # comes default or with other packages
+esac
 
-    case $distro in
-        arch|debian|ubuntu)
-            spa bash-completion
-            ;;
-        # others unknown
-    esac
+case $distro in
+    arch) spa firefox pulseaudio;;
+    *) : ;; # comes default or with other packages
+esac
 
 
-    case $distro in
-        arch) spa ttf-dejavu;;
-        debian|ubuntu) spa fonts-dejavu ;;
-        # others unknown
-    esac
+case $distro in
+    arch) spa ttf-dejavu;;
+    debian|ubuntu) spa fonts-dejavu ;;
+    # others unknown
+esac
 
-    case $distro in
-        debian|ubuntu) spa ntp;;
-        arch)
-            pi ntp
-            sgo ntpd
-            ;;
-        # others unknown
-    esac
 
-    case $distro in
-        arch) spa xorg-xev;;
-        debian|ubuntu) spa x11-utils ;;
-        # others unknown
-    esac
+case $distro in
+    arch) spa xorg-xev;;
+    debian|ubuntu) spa x11-utils ;;
+    # others unknown
+esac
 
-    case $distro in
-        arch) pi virt-install;;&
-        debian|ubuntu) pi virtinst ;;&
-        *) pi virt-manager ;; # creates the libvirt group in debian at least
-        # others unknown
-    esac
-    # allow user to run vms, from debian handbook
-    for x in ian traci; do s usermod -a -G libvirt $x; done
+case $distro in
+    arch) pi virt-install;;&
+    debian|ubuntu) pi virtinst ;;&
+    *) pi virt-manager ;; # creates the libvirt group in debian at least
+    # others unknown
+esac
+# allow user to run vms, from debian handbook
+for x in ian traci; do s usermod -a -G libvirt,kvm $x; done
 # bridge networking as user fails. google lead here, but it doesn't work:
 # oh well, I give up.
 # http://wiki.qemu.org/Features-Done/HelperNetworking
@@ -496,11 +611,11 @@ case $distro in
         # dnsmasq & ebtables for nat networking in libvirt
         # qemu for qemu-img, bind-tools for dig
         # dmidecode just because syslog complains
-        pi unzip wget xorg-xmodmap dmidecode ebtables\
+        pi unzip xorg-xmodmap dmidecode ebtables\
            bridge-utils dnsmasq qemu bind-tools
         # otherwise we get error about accessing kvm module.
         # seems like there might be a better way, but google was a bit vague.
-        s sed -ri '/^ *user *=/d' /etc/libvirt/qemu.conf
+        s sed -ri --follow-symlinks '/^ *user *=/d' /etc/libvirt/qemu.conf
         echo 'user = "root"' | s tee -a /etc/libvirt/qemu.conf
         # https://bbs.archlinux.org/viewtopic.php?id=206206
         # # this should prolly go in the wiki
@@ -512,11 +627,6 @@ case $distro in
         ;;
 esac
 
-case $distro in
-    *) pi at ;;&
-    arch) sgo atd ;;
-esac
-
 case $distro in
     arch) pi virtviewer ;;
     *) : ;; # other distros have it as a dependency afaik.
@@ -524,19 +634,6 @@ esac
 
 
 
-case $distro in
-    arch)
-        # ubuntu 14.04 uses b-cron,
-        # but it's not maintained in arch.
-        # of the ones in the main repos, cronie is only one maintained.
-        # fcron appears abandoned software.
-        pi cronie
-        sgo cronie
-        ;;
-                            *) : ;; # other distros come with cron.
-esac
-
-
 case $distro in
     fedora) cabal install shellcheck ;;
     *) spa shellcheck ;;
@@ -552,15 +649,19 @@ esac
 
 
 case $distro in
-    debian|ubuntu) spa android-tools-adb ;;
+    debian|ubuntu) spa android-tools-adb/unstable ;;
     arch) spa android-tools ;;
     # other distros unknown
 esac
 
-
 case $distro in
-    fedora) spa unrar ;;
-    *) spa unrar-free ;;
+    debian)
+        if [[ `debian-archive`  == testing ]]; then
+            # has no unstable dependencies
+            spa bitcoin-qt/unstable
+        fi
+        ;;
+    # other distros unknown
 esac
 
 
@@ -596,13 +697,12 @@ case $distro in
 esac
 
 
-# leave this for last so it doesn't do a bunch of other apps
-# which I want explicitly installed in case I switch DE's
 case $distro in
     debian)
         pi task-cinnamon-desktop
         # in settings, change scrolling to two-finger,
         # because the default edge scroll doesn\'t work.
+        pu transmission-gtk
         ;;
     # others unknown
 esac
@@ -613,7 +713,91 @@ case $distro in
     # already in debian jessie
 esac
 
-pi "${simple_packages[@]}"
+
+
+
+# note this failed running at the beginning of this file,
+# because no systemd user instance was running.
+# Doing systemd --user resulted in
+# Trying to run as user instance, but $XDG_RUNTIME_DIR is not set
+
+if isdebian-testing; then
+    # as of 7/2016, has no unstable deps, and is not in testing anymore.
+    pi synergy/unstable
+else
+    pi synergy
+fi
+
+# case $distro in
+#     # ubuntu unknown. probably the same as debian, just check if the
+#     # init scripts come with the package.
+#     debian)
+#         # copied from arch, but moved to etc
+#         s dd of=/etc/systemd/user/synergys.service <<'EOF'
+# [Unit]
+# Description=Synergy Server Daemon
+# After=network.target
+
+# [Service]
+# User=%i
+# ExecStart=/usr/bin/synergys --no-daemon --config /etc/synergy.conf
+# Restart=on-failure
+
+# [Install]
+# WantedBy=multi-user.target
+# EOF
+#         s dd of=/etc/systemd/user/synergys.socket <<'EOF'
+# [Unit]
+# Conflicts=synergys@.service
+
+# [Socket]
+# ListenStream=24800
+# Accept=false
+
+# [Install]
+# WantedBy=sockets.target
+# EOF
+#         # had this fail with 'Failed to connect to bus: No such file or directory'
+#         # then when I tried it manually, it worked fine...
+#         if ! systemctl --user daemon-reload; then
+#             sleep 2
+#             echo retrying systemd user daemon reload
+#             systemctl --user daemon-reload
+#         fi
+#         ;;&
+#     *)
+#         # taken from arch wiki.
+#         s dd of=/etc/systemd/system/synergyc@.service <<'EOF'
+# [Unit]
+# Description=Synergy Client
+# After=network.target
+
+# [Service]
+# User=%i
+# ExecStart=/usr/bin/synergyc --no-daemon frodo
+# Restart=on-failure
+# # per man systemd.unit, StartLimitInterval, by default we
+# # restart more than 5 times in 10 seconds.
+# # And this param defaults too 200 miliseconds.
+# RestartSec=3s
+
+# [Install]
+# WantedBy=multi-user.target
+# EOF
+#         s systemctl daemon-reload
+#         case $HOSTNAME in
+#             x2|treetowl)
+#                 ser enable synergyc@ian
+#                 ser start synergyc@ian ||: # X might not be running yet
+#                 ;;
+#             frodo)
+#                 systemctl --user start synergys ||:
+#                 systemctl --user enable synergys
+#                 ;;
+#         esac
+#         ;;
+# esac
+
 
 ######### end misc packages #########
 
@@ -628,6 +812,8 @@ pi "${simple_packages[@]}"
 ######## unfinished
 
 # todo, finish configuring smart.
+
+pi smartmontools
 # mostly from https://wiki.archlinux.org/index.php/S.M.A.R.T.
 # turn on smart. background on options:
 # first line, -a = test everyting on all devices.
@@ -636,8 +822,8 @@ pi "${simple_packages[@]}"
 # -o on, turn on 4 hour period non-performance degrading testing.
 # short test daily 2-3am, extended tests Saturdays between 3-4am:
 sched="-s (S/../.././02|L/../../6/03)"
-s sed -i "s#^[[:space:]]*DEVICESCAN.*#\
-DEVICESCAN -a -o on -S on -n standby,q $sched\
+s sed -i --follow-symlinks "s#^[[:space:]]*DEVICESCAN.*#\
+DEVICESCAN -a -o on -S on -n standby,q $sched \
 -m ian@iankelling.org -M exec /usr/local/bin/smart-notify#" /etc/smartd.conf
 
 # in the default configuration of at least ubuntu 14.04, resolvconf is
@@ -646,7 +832,7 @@ DEVICESCAN -a -o on -S on -n standby,q $sched\
 # consulted first. This is often slower and undesirable, ie. local dns
 # queries go from 0ms to 10+ or 100+ ms. To reverse the ordering, you
 # can do:
-#sudo sed -i '/tun\*\|tap\*/d' /etc/resolvconf/interface-order
+#sudo sed -i --follow-symlinks '/tun\*\|tap\*/d' /etc/resolvconf/interface-order
 # however, this breaks dns lookup for hosts on the openvpn lan.
 # I can\'t figure out why hosts on the normal lan would not be
 # broken under the default ordering, except the host I was
@@ -656,21 +842,51 @@ DEVICESCAN -a -o on -S on -n standby,q $sched\
 
 ########### misc stuff
 
-if [[ $HOSTNAME == frodo ]]; then
-    tu /etc/exports <<'EOF'
-/k 192.168.1.0/24(rw,nohide,no_subtree_check,insecure)
+
+s cedit /etc/goaccess.conf <<'EOF' || [[ $? == 1 ]]
+# all things found from looking around the default config
+# copied existing NCSA Combined Log Format with Virtual Host, plus %L
+log-format %^:%^ %h %^[%d:%t %^] "%r" %s %b "%R" "%u" %D
+time-format %H:%M:%S
+date-format %d/%b/%Y
+log-file /var/log/apache2/access.log
+color-scheme 2
+
+# tip: copy access.log files to a stretch host directory, then run
+# jessie's goaccess is too old for some options, and it's
+# not easily installed from a testing.
+# goaccess --ignore-crawlers -f <(cat *) -a -o html > x.html
 EOF
-    s exportfs -ra
+
+
+if [[ $HOSTNAME == treetowl ]] && ! sudo test -e /etc/openvpn/client.key; then
+    /a/bin/vpn-setup/vpn-mk-client-cert dopub
 fi
 
-if [[ `debian-archive` == stable ]]; then
-    s dd of=/etc/apt/preferences.d/unison-gtk <<'EOF'
+
+case $distro in
+    debian|ubuntu)
+        case `debian-archive` in
+            stable)
+                s dd of=/etc/apt/preferences.d/unison-gtk <<'EOF'
 Explanation: Allow unison-gtk to be upgraded
 Package: unison-gtk
 Pin: release a=unstable
 Pin-Priority: 500
 EOF
-fi
+                # dont think using testing is needed since I figured out how to
+                # deal with mismatching unison compilers, but I dont
+                # see any reason to revert it, since it only installs
+                # a single package which is primarily a single binary
+                ;;
+        esac
+        pi unison/testing
+        pi unison-gtk/testing # after to make it the default unison
+        ;;
+    arch)
+        pi unison gtk2
+        ;;
+esac
 
 case $distro in
     arch)
@@ -681,11 +897,13 @@ EOF
         ;;
 esac
 
-
-case $distro in
-    arch|debian|ubuntu) pi btrbk ;;
-    # others unknown
-esac
+# note, for jessie, it depends on a higher version of btrfs-tools
+# case $distro in
+#     arch|debian|ubuntu) pi btrbk ;;
+#     # others unknown
+# esac
+cd /a/opt/btrbk
+s make install
 
 if [[ $HOSTNAME == treetowl ]] && [[ `debian-archive` != testing ]]; then
     # fail2 ban is broken, with a workaround, per
@@ -697,128 +915,6 @@ fi
 
 
 
-# disable motd junk.
-case $(distro-name) in
-    debian)
-        # allows me to pipe with ssh -t, and gets rid of spam
-        # http://forums.debian.net/viewtopic.php?f=5&t=85822
-        # i'd rather disable the service than comment the init file
-        # this says disabling the service, it will still get restarted
-        # but this script doesn't do anything on restart, so it should be fine
-        s dd of=/var/run/motd.dynamic if=/dev/null
-        s update-rc.d motd disable
-        ;;
-    ubuntu)
-        # this isn't a complete solution. It still shows me when updates are available,
-        # but it's no big deal.
-        s t /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
-        ;;
-esac
-
-# automatic updates
-# reference:
-# https://debian-handbook.info/browse/stable/sect.regular-upgrades.html
-# /etc/cron.daily/apt calls unattended-upgrades
-# /usr/share/doc/unattended-upgrades# cat README.md
-# /etc/apt/apt.conf.d/50unattended-upgrades
-if isdebian; then
-    pi unattended-upgrades
-    s dd of=/etc/apt/apt.conf.d/10periodic <<'EOF'
-# this file was mostly just comments.
-APT::Periodic::Update-Package-Lists "1";
-APT::Periodic::Download-Upgradeable-Packages "1";
-APT::Periodic::AutocleanInterval "7";
-APT::Periodic::Unattended-Upgrade "1";
-EOF
-    { cat  <<'EOF'
-Unattended-Upgrade::Mail "root";
-Unattended-Upgrade::MailOnlyOnError "true";
-Unattended-Upgrade::Remove-Unused-Dependencies "true";
-Unattended-Upgrade::Origins-Pattern {
-# default is just upgrade main and security, not updates.
-EOF
-      if isdebian-testing; then
-          cat <<'EOF'
-# for testing, only do security updates.
-       "origin=Debian,codename=${distro_codename},label=Debian-Security";
-EOF
-      else
-          cat <<'EOF'
-# These are stable packages only getting bugfixes anyways.
-       "origin=*";
-EOF
-          cat <<'EOF'
-};
-EOF
-      fi
-    } | s dd of=/etc/apt/apt.conf.d/50unattended-upgrades
-    echo $- > /tmp/x
-fi
-
-
-
-######### begin  postfix ########
-# based on,http://www.postfix.org/qmgr.8.html and my notes in gnus
-# originally tried moving specific directories under /var/spool/postfix,
-# but postfix didn't like that
-if [[ ! -L /var/spool/postfix ]]; then
-    ser stop postfix
-    n=/q/postfix-`distro-name``debian-archive`
-    if [[ -e $n ]]; then
-        echo "$0: warning: $n already exists before we do the link, removing it"
-        rm -rf $n
-    fi
-    s mv /var/spool/postfix $n
-    s lnf -T $n /var/spool/postfix
-    ser start postfix
-    journalctl -n 20 | cat
-fi
-
-
-# This also works instead of ~/.forward
-# s sed -i '/^root/d' /etc/aliases ||:
-#echo "root: $HOSTNAME@bog.mm.st" | s tee -a /etc/aliases
-# this can't be a symlink and has permission restrictions
-# it might work in /etc/aliases, but this seems more proper.
-
-if s grep amazonaws /etc/postfix/sasl_passwd &>/dev/null; then
-    forward=$HOSTNAME@sallymae.club
-else
-    forward=$HOSTNAME@bog.mm.st
-fi
-e $forward > ~/.forward
-e $forward | s tee /root/.forward
-s newaliases
-
-# if I wanted the from address to be renamed and sent to a different address,
-# echo "sdx@localhost development@localhost" | sudo dd of=/etc/postfix/recipient_canonical
-# sudo postmap hash:/etc/postfix/recipient_canonical
-# sudo service postfix reload
-
-
-# i'm assuming mail just won't work on systems without the sasl_passwd.
-postconfin <<'EOF'
-smtp_sasl_auth_enable = yes
-smtp_sasl_password_maps = hash:/etc/postfix/sasl_passwd
-smtp_sasl_security_options = noanonymous
-smtp_tls_security_level = secure
-message_size_limit =  20480000
-smtp_tls_CAfile = /etc/ssl/certs/ca-certificates.crt
-EOF
-# ^ I ran into a log file not sending cuz of size. double from 10 to 20 meg limit
-
-s postmap hash:/etc/postfix/sasl_passwd
-# offlineimap uses this too, it is much easier to use one location than to
-# condition it's config and postfix's config
-case $distro in
-    fedora) s lnf -T ca-certificates.crt /etc/ssl/ca-bundle.trust.crt ;;
-    *) :
-esac
-
-s service postfix reload
-sgo postfix
-
-############ end postfix #######
 
 
 case $distro in
@@ -911,24 +1007,19 @@ EOF
         ;;
 esac
 
-if [[ -e /i/video ]]; then
+if [[ $HOSTNAME == treetowl ]]; then
     # nohide = export filesystems mounted deeper than the export point
     # fsid=0 makes this export the "root" export
     # not documented in the man page, but this means
     # 1. it can be mounted with a shorthand of server:/
     # 2. exports that are subdirectories of this one will automatically be mounted
-    tu /etc/exports '/i/video 192.168.1.0/24(rw,fsid=0,nohide,no_root_squash,async,no_subtree_check,insecure)'
+    tu /etc/exports <<'EOF'
+/k 192.168.1.0/24(rw,fsid=0,nohide,no_root_squash,async,no_subtree_check,insecure)
+EOF
     s exportfs -rav
-    showmount -e localhost
 fi
 
 
-# cron
-f=/a/bin/$HOSTNAME-crontab
-if [[ -e $f ]]; then
-    $f
-fi
-
 e "$end_msg_var"
 
 
@@ -993,64 +1084,72 @@ if ! s virsh list --all --name | grep -xF win10 &>/dev/null; then
 fi
 
 
-pi samba
-# note samba re-reads it's config every 1 minute
-case $distro in
-    arch) s cp /etc/samba/smb.conf.default /etc/samba/smb.conf ;;
-esac
+if [[ $HOSTNAME == treetowl ]]; then
+    pi samba
+    # note samba re-reads it\'s config every 1 minute
+    case $distro in
+        arch) s cp /etc/samba/smb.conf.default /etc/samba/smb.conf ;;
+    esac
 
-# add 2 lines after workgroup option
-s sed -ri '/^\s*encrypt passwords\s*=/d' /etc/samba/smb.conf
-s sed -ri '/^\s*map to guest\s*=/d' /etc/samba/smb.conf
-s sed -i 's/\(\s*workgroup\s*=\).*/\1 WORKGROUP\n\tencrypt passwords = yes\n\tmap to guest = bad password/'  /etc/samba/smb.conf
-# remove default homes section. not sharing that.
-s sed -ri '/^\s*\[homes\]/,/\s*\[/d' /etc/samba/smb.conf
+    # add 2 lines after workgroup option
+    s sed -ri --follow-symlinks '/^\s*encrypt passwords\s*=/d' /etc/samba/smb.conf
+    s sed -ri --follow-symlinks '/^\s*map to guest\s*=/d' /etc/samba/smb.conf
+    s sed -i --follow-symlinks 's/\(\s*workgroup\s*=\).*/\1 WORKGROUP\n\tencrypt passwords = yes\n\tmap to guest = bad password/'  /etc/samba/smb.conf
+    # remove default homes section. not sharing that.
+    s sed -ri --follow-symlinks '/^\s*\[homes\]/,/\s*\[/d' /etc/samba/smb.conf
 
-if ! grep -xF '[public]' /etc/samba/smb.conf &>/dev/null; then
-    s tee -a /etc/samba/smb.conf <<'EOF'
+    if ! grep -xF '[public]' /etc/samba/smb.conf &>/dev/null; then
+        s tee -a /etc/samba/smb.conf <<'EOF'
 [public]
       guest ok = yes
       read only = no
-      path = /kfrodo
+      path = /kr
 EOF
+    fi
+
+    case $distro in
+        debian|ubuntu)
+            # systemd claims it generates units from /etc/init.d, but it
+            # clearly doesn\'t in debian. I have no idea how they are
+            # related. fuck debian right now. It\'s not documented.  samba
+            # has a systemd init file linked to /dev/null.  There\'s this
+            # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=769714 which
+            # claims samba\'s sub-services will be started automatically by
+            # systemd... it didn\'t on install, wonder if it will on
+            # boot. It clued me in how to start it manually though. Nothing
+            # in /usr/share/doc/samba, debian admin guide says nothing about
+            # any of this. (this is in debian testing as of 4/2016).
+
+            s /etc/init.d/samba start
+            ;;
+        arch)
+            sgo samba
+            ;;
+    esac
 fi
 
+tu /etc/hosts <<< "127.0.1.1 $(hostname).lan $(hostname)"
+
+
+######### begin stuff belonging at the end    ##########
+
+
+# Apps we want to override others for default file handler:
+# simplest way in debian is to just install them last.
+simple_packages+=(
+    mpv
+)
+
 case $distro in
-    debian|ubuntu)
-# systemd claims it generates units from /etc/init.d, but it clearly doesn't
-# in debian. I have no idea how they are related. fuck debian right now. It's
-# not documented.  samba has a systemd init file linked to /dev/null.
-# There's this https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=769714 which
-# claims samba's sub-services will be started automatically by systemd... it
-# didn't on install, wonder if it will on boot. It clued me in how to start
-# it manually though. Nothing in /usr/share/doc/samba, debian admin guide
-# says nothing about any of this. (this is in debian testing as of 4/2016).
-
-s /etc/init.d/samba start
-;;
+    ubuntu|debian)
+        spa spacefm-gtk3 ;;
     arch)
-        sgo samba
-        ;;
+        spa spacefm ;;
 esac
 
-tu /etc/hosts <<< "127.0.1.1 $(hostname).lan $(hostname)"
-
 
+pi "${simple_packages[@]}"
 
-rootdev=$(mount | sed -rn 's#^(\S+) on / .*#\1#p')
-s mkdir /mnt/root
-tu /etc/fstab <<< "$rootdev  /mnt/root  btrfs  noatime,subvolid=0  0 0"
-s mount /mnt/root || [[ $? == 32 ]]
-idev=$(mount | sed -rn 's#^(\S+) on /i .*#\1#p')
-if [[ $idev != $rootdev ]]; then
-    s mkdir /mnt/iroot
-    tu /etc/fstab <<< "$idev  /mnt/iroot  btrfs  noatime,subvolid=0  0 0"
-    s mount /mnt/iroot || [[ $? == 32 ]]
-fi
-
-# Do this again because it occasionally has changes and
-# it can be run outside initial isntall.
-s /a/bin/fai/fai/config/distro-install-common/end
 
 if $pending_reboot; then
     echo "$0: pending reboot and then finished. doing it now."